Index: main/trunk/greenstone2/ext/tika/README.txt
===================================================================
--- main/trunk/greenstone2/ext/tika/README.txt	(revision 34194)
+++ main/trunk/greenstone2/ext/tika/README.txt	(revision 35401)
@@ -1,2 +1,14 @@
+--------------------------------------------------------------
+About tika-app.jar:
+--------------------------------------------------------------
+Last updated version is currently 1.24.1 (tika-app-1.24.1.jar)
+which can be found in the final line of output of running:
+	java -jar %GSDLHOME%\ext\tika\tika-app.jar --version
+on Windows:
+or on Linux,
+	java -jar $GSDLHOME/ext/tika/tika-app.jar --version
+
+
+
 --------------------------------------------------------------
 A. Some background information on Apache Tika and related:
@@ -28,26 +40,26 @@
 1. HTML:	
 
-GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --html /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.htm
+GS3/gs2build/ext/tika>java -jar tika-app.jar --html /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.htm
 
 2. XHTML - looks the same as HTML:
 
-GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --xml /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html
+GS3/gs2build/ext/tika>java -jar tika-app.jar --xml /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html
 
 3. PLAIN TEXT CONTENT - NO META:
 
-GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --text-main /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html
+GS3/gs2build/ext/tika>java -jar tika-app.jar --text-main /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html
 
   a. PLAIN TEXT WITH META:
 
-GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --text /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html
+GS3/gs2build/ext/tika>java -jar tika-app.jar --text /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html
 
   b. JUST META:
 
-GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --metadata /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html)
+GS3/gs2build/ext/tika>java -jar tika-app.jar --metadata /PATH/TO/testword.docx > /PATH/TO/GS3/gs2build/ext/tmp/testword.html)
 	
 4. IMAGES CAN'T DO HTML + IMAGES IN ONE STEP by throwing in any of the above flags in addition):
 
 Extracts all attachments (images etc) into specified dir (-z or --extract and then specify a dir for it)
-GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --extract --extract-dir=/PATH/TO/GS3/gs2build/ext/tmp /PATH/TO/testword.docx		
+GS3/gs2build/ext/tika>java -jar tika-app.jar --extract --extract-dir=/PATH/TO/GS3/gs2build/ext/tmp /PATH/TO/testword.docx		
 
 
@@ -55,5 +67,5 @@
 C. COMPARE OUTPUT - IMG EXTRACTION vs TEXT:
 --------------------------------------------------------------
-* GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar -z --extract-dir=/PATH/TO/GS3/gs2build/ext/tmp /PATH/TO/testword.docx
+* GS3/gs2build/ext/tika>java -jar tika-app.jar -z --extract-dir=/PATH/TO/GS3/gs2build/ext/tmp /PATH/TO/testword.docx
 
 INFO  As a convenience, TikaCLI has turned on extraction of
@@ -72,5 +84,5 @@
 
 
-* GS3/gs2build/ext/tika>java -jar tika-app-1.24.1.jar --text-main /PATH/TO/testword.docx
+* GS3/gs2build/ext/tika>java -jar tika-app.jar --text-main /PATH/TO/testword.docx
 
 Jun 14, 2020 1:29:42 AM org.apache.tika.config.InitializableProblemHandler$3 handleInitializableProblem
@@ -89,5 +101,5 @@
 D. THE --encoding= FLAG TO TIKA
 --------------------------------------------------------------
-> java -jar tika-app-1.24.1.jar --help
+> java -jar tika-app.jar --help
   ...
   -eX or --encoding=X    Use output encoding X
@@ -104,5 +116,5 @@
 COMPARE, noting also the case of the encoding in the Tika command, vs in the output:
 
-(1) >java -jar tika-app-1.24.1.jar --encoding=iso-8859-1 /Scratch/ak19/testword.docx
+(1) >java -jar tika-app.jar --encoding=iso-8859-1 /Scratch/ak19/testword.docx
   <?xml version="1.0" encoding="utf-8"?><html xmlns="http://www.w3.org/1999/xhtml">
   <head>
@@ -110,20 +122,20 @@
   ...
 
-(2) >java -jar tika-app-1.24.1.jar --encoding=UTF-8 /Scratch/ak19/testword.docx
+(2) >java -jar tika-app.jar --encoding=UTF-8 /Scratch/ak19/testword.docx
     <?xml version="1.0" encoding="UTF-8"?><html xmlns="http://www.w3.org/1999/xhtml">
     <head>
     ...
 
-(3) >java -jar tika-app-1.24.1.jar --encoding=iso-8859-1 /Scratch/ak19/testword.docx
+(3) >java -jar tika-app.jar --encoding=iso-8859-1 /Scratch/ak19/testword.docx
     <?xml version="1.0" encoding="ISO-8859-1"?><html xmlns="http://www.w3.org/1999/xhtml">
     <head>
     ...
   
-(4) >java -jar tika-app-1.24.1.jar --encoding=ISO-8859-1 /Scratch/ak19/testword.docx
+(4) >java -jar tika-app.jar --encoding=ISO-8859-1 /Scratch/ak19/testword.docx
     <?xml version="1.0" encoding="ISO-8859-1"?><html xmlns="http://www.w3.org/1999/xhtml">
     <head>
      ...
 
-(5) >java -jar tika-app-1.24.1.jar --encoding=nonexistent /Scratch/ak19/testword.docx
+(5) >java -jar tika-app.jar --encoding=nonexistent /Scratch/ak19/testword.docx
     Warning:  The encoding 'nonexistent' is not supported by the Java runtime.
     Warning: encoding "nonexistent" not supported, using UTF-8
@@ -133,5 +145,5 @@
 
 (6) (Output to html)
-    > java -jar tika-app-1.24.1.jar --encoding=nonexistent --html /Scratch/ak19/testword.docx
+    > java -jar tika-app.jar --encoding=nonexistent --html /Scratch/ak19/testword.docx
     Warning:  The encoding 'nonexistent' is not supported by the Java runtime.
     Warning: encoding "nonexistent" not supported, using UTF-8
@@ -144,5 +156,5 @@
 
 (7) (Output to html case 2)
-    > java -jar tika-app-1.24.1.jar --html --encoding=iso-8859-1 /Scratch/ak19/testword.docx
+    > java -jar tika-app.jar --html --encoding=iso-8859-1 /Scratch/ak19/testword.docx
     <html xmlns="http://www.w3.org/1999/xhtml">
     <head>